<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/object-0.29.0/src/read/traits.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>traits.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../object/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">alloc::borrow::Cow</span>;
<span class="kw">use</span> <span class="ident">alloc::vec::Vec</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::read</span>::{
    <span class="self">self</span>, <span class="ident">Architecture</span>, <span class="ident">CodeView</span>, <span class="ident">ComdatKind</span>, <span class="ident">CompressedData</span>, <span class="ident">CompressedFileRange</span>, <span class="ident">Export</span>,
    <span class="ident">FileFlags</span>, <span class="ident">Import</span>, <span class="ident">ObjectKind</span>, <span class="ident">ObjectMap</span>, <span class="ident">Relocation</span>, <span class="prelude-ty">Result</span>, <span class="ident">SectionFlags</span>, <span class="ident">SectionIndex</span>,
    <span class="ident">SectionKind</span>, <span class="ident">SegmentFlags</span>, <span class="ident">SymbolFlags</span>, <span class="ident">SymbolIndex</span>, <span class="ident">SymbolKind</span>, <span class="ident">SymbolMap</span>, <span class="ident">SymbolMapName</span>,
    <span class="ident">SymbolScope</span>, <span class="ident">SymbolSection</span>,
};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Endianness</span>;

<span class="doccomment">/// An object file.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Object</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>: <span class="lifetime">&#39;file</span>, <span class="lifetime">&#39;file</span><span class="op">&gt;</span>: <span class="ident">read::private::Sealed</span> {
    <span class="doccomment">/// A segment in the object file.</span>
    <span class="kw">type</span> <span class="ident">Segment</span>: <span class="ident">ObjectSegment</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>;

    <span class="doccomment">/// An iterator over the segments in the object file.</span>
    <span class="kw">type</span> <span class="ident">SegmentIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::Segment</span><span class="op">&gt;</span>;

    <span class="doccomment">/// A section in the object file.</span>
    <span class="kw">type</span> <span class="ident">Section</span>: <span class="ident">ObjectSection</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>;

    <span class="doccomment">/// An iterator over the sections in the object file.</span>
    <span class="kw">type</span> <span class="ident">SectionIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::Section</span><span class="op">&gt;</span>;

    <span class="doccomment">/// A COMDAT section group in the object file.</span>
    <span class="kw">type</span> <span class="ident">Comdat</span>: <span class="ident">ObjectComdat</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>;

    <span class="doccomment">/// An iterator over the COMDAT section groups in the object file.</span>
    <span class="kw">type</span> <span class="ident">ComdatIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::Comdat</span><span class="op">&gt;</span>;

    <span class="doccomment">/// A symbol in the object file.</span>
    <span class="kw">type</span> <span class="ident">Symbol</span>: <span class="ident">ObjectSymbol</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>;

    <span class="doccomment">/// An iterator over symbols in the object file.</span>
    <span class="kw">type</span> <span class="ident">SymbolIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::Symbol</span><span class="op">&gt;</span>;

    <span class="doccomment">/// A symbol table in the object file.</span>
    <span class="kw">type</span> <span class="ident">SymbolTable</span>: <span class="ident">ObjectSymbolTable</span><span class="op">&lt;</span>
        <span class="lifetime">&#39;data</span>,
        <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::Symbol</span>,
        <span class="ident">SymbolIterator</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::SymbolIterator</span>,
    <span class="op">&gt;</span>;

    <span class="doccomment">/// An iterator over dynamic relocations in the file.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The first field in the item tuple is the address</span>
    <span class="doccomment">/// that the relocation applies to.</span>
    <span class="kw">type</span> <span class="ident">DynamicRelocationIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> (<span class="ident">u64</span>, <span class="ident">Relocation</span>)<span class="op">&gt;</span>;

    <span class="doccomment">/// Get the architecture type of the file.</span>
    <span class="kw">fn</span> <span class="ident">architecture</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Architecture</span>;

    <span class="doccomment">/// Get the endianness of the file.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">endianness</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Endianness</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">is_little_endian</span>() {
            <span class="ident">Endianness::Little</span>
        } <span class="kw">else</span> {
            <span class="ident">Endianness::Big</span>
        }
    }

    <span class="doccomment">/// Return true if the file is little endian, false if it is big endian.</span>
    <span class="kw">fn</span> <span class="ident">is_little_endian</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Return true if the file can contain 64-bit addresses.</span>
    <span class="kw">fn</span> <span class="ident">is_64</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Return the kind of this object.</span>
    <span class="kw">fn</span> <span class="ident">kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">ObjectKind</span>;

    <span class="doccomment">/// Get an iterator over the segments in the file.</span>
    <span class="kw">fn</span> <span class="ident">segments</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::SegmentIterator</span>;

    <span class="doccomment">/// Get the section named `section_name`, if such a section exists.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If `section_name` starts with a &#39;.&#39; then it is treated as a system section name,</span>
    <span class="doccomment">/// and is compared using the conventions specific to the object file format. This</span>
    <span class="doccomment">/// includes:</span>
    <span class="doccomment">/// - if &quot;.debug_str_offsets&quot; is requested for a Mach-O object file, then the actual</span>
    <span class="doccomment">/// section name that is searched for is &quot;__debug_str_offs&quot;.</span>
    <span class="doccomment">/// - if &quot;.debug_info&quot; is requested for an ELF object file, then</span>
    <span class="doccomment">/// &quot;.zdebug_info&quot; may be returned (and similarly for other debug sections).</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// For some object files, multiple segments may contain sections with the same</span>
    <span class="doccomment">/// name. In this case, the first matching section will be used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method skips over sections with invalid names.</span>
    <span class="kw">fn</span> <span class="ident">section_by_name</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>, <span class="ident">section_name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Section</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">section_by_name_bytes</span>(<span class="ident">section_name</span>.<span class="ident">as_bytes</span>())
    }

    <span class="doccomment">/// Like [`Self::section_by_name`], but allows names that are not UTF-8.</span>
    <span class="kw">fn</span> <span class="ident">section_by_name_bytes</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>, <span class="ident">section_name</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Section</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get the section at the given index.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The meaning of the index depends on the object file.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// For some object files, this requires iterating through all sections.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the index is invalid.</span>
    <span class="kw">fn</span> <span class="ident">section_by_index</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>, <span class="ident">index</span>: <span class="ident">SectionIndex</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Section</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get an iterator over the sections in the file.</span>
    <span class="kw">fn</span> <span class="ident">sections</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::SectionIterator</span>;

    <span class="doccomment">/// Get an iterator over the COMDAT section groups in the file.</span>
    <span class="kw">fn</span> <span class="ident">comdats</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::ComdatIterator</span>;

    <span class="doccomment">/// Get the symbol table, if any.</span>
    <span class="kw">fn</span> <span class="ident">symbol_table</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::SymbolTable</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get the debugging symbol at the given index.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The meaning of the index depends on the object file.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the index is invalid.</span>
    <span class="kw">fn</span> <span class="ident">symbol_by_index</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>, <span class="ident">index</span>: <span class="ident">SymbolIndex</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Symbol</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get an iterator over the debugging symbols in the file.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This may skip over symbols that are malformed or unsupported.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// For Mach-O files, this does not include STAB entries.</span>
    <span class="kw">fn</span> <span class="ident">symbols</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::SymbolIterator</span>;

    <span class="doccomment">/// Get the dynamic linking symbol table, if any.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Only ELF has a separate dynamic linking symbol table.</span>
    <span class="kw">fn</span> <span class="ident">dynamic_symbol_table</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::SymbolTable</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get an iterator over the dynamic linking symbols in the file.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This may skip over symbols that are malformed or unsupported.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Only ELF has separate dynamic linking symbols.</span>
    <span class="doccomment">/// Other file formats will return an empty iterator.</span>
    <span class="kw">fn</span> <span class="ident">dynamic_symbols</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::SymbolIterator</span>;

    <span class="doccomment">/// Get the dynamic relocations for this file.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Symbol indices in these relocations refer to the dynamic symbol table.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Only ELF has dynamic relocations.</span>
    <span class="kw">fn</span> <span class="ident">dynamic_relocations</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::DynamicRelocationIterator</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Construct a map from addresses to symbol names.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The map will only contain defined text and data symbols.</span>
    <span class="doccomment">/// The dynamic symbol table will only be used if there are no debugging symbols.</span>
    <span class="kw">fn</span> <span class="ident">symbol_map</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident">SymbolMap</span><span class="op">&lt;</span><span class="ident">SymbolMapName</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">symbols</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">table</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">symbol_table</span>().<span class="ident">or_else</span>(<span class="op">|</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">dynamic_symbol_table</span>()) {
            <span class="kw">for</span> <span class="ident">symbol</span> <span class="kw">in</span> <span class="ident">table</span>.<span class="ident">symbols</span>() {
                <span class="kw">if</span> <span class="op">!</span><span class="ident">symbol</span>.<span class="ident">is_definition</span>() {
                    <span class="kw">continue</span>;
                }
                <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="ident">name</span>) <span class="op">=</span> <span class="ident">symbol</span>.<span class="ident">name</span>() {
                    <span class="ident">symbols</span>.<span class="ident">push</span>(<span class="ident">SymbolMapName::new</span>(<span class="ident">symbol</span>.<span class="ident">address</span>(), <span class="ident">name</span>));
                }
            }
        }
        <span class="ident">SymbolMap::new</span>(<span class="ident">symbols</span>)
    }

    <span class="doccomment">/// Construct a map from addresses to symbol names and object file names.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is derived from Mach-O STAB entries.</span>
    <span class="kw">fn</span> <span class="ident">object_map</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident">ObjectMap</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
        <span class="ident">ObjectMap::default</span>()
    }

    <span class="doccomment">/// Get the imported symbols.</span>
    <span class="kw">fn</span> <span class="ident">imports</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Import</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get the exported symbols that expose both a name and an address.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Some file formats may provide other kinds of symbols, that can be retrieved using</span>
    <span class="doccomment">/// the lower-level API.</span>
    <span class="kw">fn</span> <span class="ident">exports</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Export</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Return true if the file contains debug information sections, false if not.</span>
    <span class="kw">fn</span> <span class="ident">has_debug_symbols</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// The UUID from a Mach-O `LC_UUID` load command.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">mach_uuid</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span>[<span class="ident">u8</span>; <span class="number">16</span>]<span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
    }

    <span class="doccomment">/// The build ID from an ELF `NT_GNU_BUILD_ID` note.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">build_id</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
    }

    <span class="doccomment">/// The filename and CRC from a `.gnu_debuglink` section.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">gnu_debuglink</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>], <span class="ident">u32</span>)<span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
    }

    <span class="doccomment">/// The filename and build ID from a `.gnu_debugaltlink` section.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">gnu_debugaltlink</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>], <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>])<span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
    }

    <span class="doccomment">/// The filename and GUID from the PE CodeView section</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">pdb_info</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">CodeView</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
    }

    <span class="doccomment">/// Get the base address used for relative virtual addresses.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Currently this is only non-zero for PE.</span>
    <span class="kw">fn</span> <span class="ident">relative_address_base</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Get the virtual address of the entry point of the binary</span>
    <span class="kw">fn</span> <span class="ident">entry</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;file</span> <span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// File flags that are specific to each file format.</span>
    <span class="kw">fn</span> <span class="ident">flags</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">FileFlags</span>;
}

<span class="doccomment">/// A loadable segment defined in an object file.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For ELF, this is a program header with type `PT_LOAD`.</span>
<span class="doccomment">/// For Mach-O, this is a load command with type `LC_SEGMENT` or `LC_SEGMENT_64`.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">ObjectSegment</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>: <span class="ident">read::private::Sealed</span> {
    <span class="doccomment">/// Returns the virtual address of the segment.</span>
    <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Returns the size of the segment in memory.</span>
    <span class="kw">fn</span> <span class="ident">size</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Returns the alignment of the segment in memory.</span>
    <span class="kw">fn</span> <span class="ident">align</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Returns the offset and size of the segment in the file.</span>
    <span class="kw">fn</span> <span class="ident">file_range</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; (<span class="ident">u64</span>, <span class="ident">u64</span>);

    <span class="doccomment">/// Returns a reference to the file contents of the segment.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The length of this data may be different from the size of the</span>
    <span class="doccomment">/// segment in memory.</span>
    <span class="kw">fn</span> <span class="ident">data</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>;

    <span class="doccomment">/// Return the segment data in the given range.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns `Ok(None)` if the segment does not contain the given range.</span>
    <span class="kw">fn</span> <span class="ident">data_range</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">address</span>: <span class="ident">u64</span>, <span class="ident">size</span>: <span class="ident">u64</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the name of the segment.</span>
    <span class="kw">fn</span> <span class="ident">name_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the name of the segment.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the name is not UTF-8.</span>
    <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Return the flags of segment.</span>
    <span class="kw">fn</span> <span class="ident">flags</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SegmentFlags</span>;
}

<span class="doccomment">/// A section defined in an object file.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">ObjectSection</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>: <span class="ident">read::private::Sealed</span> {
    <span class="doccomment">/// An iterator over the relocations for a section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The first field in the item tuple is the section offset</span>
    <span class="doccomment">/// that the relocation applies to.</span>
    <span class="kw">type</span> <span class="ident">RelocationIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> (<span class="ident">u64</span>, <span class="ident">Relocation</span>)<span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the section index.</span>
    <span class="kw">fn</span> <span class="ident">index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SectionIndex</span>;

    <span class="doccomment">/// Returns the address of the section.</span>
    <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Returns the size of the section in memory.</span>
    <span class="kw">fn</span> <span class="ident">size</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Returns the alignment of the section in memory.</span>
    <span class="kw">fn</span> <span class="ident">align</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Returns offset and size of on-disk segment (if any).</span>
    <span class="kw">fn</span> <span class="ident">file_range</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">u64</span>, <span class="ident">u64</span>)<span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the raw contents of the section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The length of this data may be different from the size of the</span>
    <span class="doccomment">/// section in memory.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This does not do any decompression.</span>
    <span class="kw">fn</span> <span class="ident">data</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>;

    <span class="doccomment">/// Return the raw contents of the section data in the given range.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This does not do any decompression.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns `Ok(None)` if the section does not contain the given range.</span>
    <span class="kw">fn</span> <span class="ident">data_range</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">address</span>: <span class="ident">u64</span>, <span class="ident">size</span>: <span class="ident">u64</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the potentially compressed file range of the section,</span>
    <span class="doccomment">/// along with information about the compression.</span>
    <span class="kw">fn</span> <span class="ident">compressed_file_range</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">CompressedFileRange</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the potentially compressed contents of the section,</span>
    <span class="doccomment">/// along with information about the compression.</span>
    <span class="kw">fn</span> <span class="ident">compressed_data</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">CompressedData</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the uncompressed contents of the section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The length of this data may be different from the size of the</span>
    <span class="doccomment">/// section in memory.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If no compression is detected, then returns the data unchanged.</span>
    <span class="doccomment">/// Returns `Err` if decompression fails.</span>
    <span class="kw">fn</span> <span class="ident">uncompressed_data</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">compressed_data</span>()<span class="question-mark">?</span>.<span class="ident">decompress</span>()
    }

    <span class="doccomment">/// Returns the name of the section.</span>
    <span class="kw">fn</span> <span class="ident">name_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the name of the section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the name is not UTF-8.</span>
    <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the name of the segment for this section.</span>
    <span class="kw">fn</span> <span class="ident">segment_name_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the name of the segment for this section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the name is not UTF-8.</span>
    <span class="kw">fn</span> <span class="ident">segment_name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Return the kind of this section.</span>
    <span class="kw">fn</span> <span class="ident">kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SectionKind</span>;

    <span class="doccomment">/// Get the relocations for this section.</span>
    <span class="kw">fn</span> <span class="ident">relocations</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::RelocationIterator</span>;

    <span class="doccomment">/// Section flags that are specific to each file format.</span>
    <span class="kw">fn</span> <span class="ident">flags</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SectionFlags</span>;
}

<span class="doccomment">/// A COMDAT section group defined in an object file.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">ObjectComdat</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>: <span class="ident">read::private::Sealed</span> {
    <span class="doccomment">/// An iterator over the sections in the object file.</span>
    <span class="kw">type</span> <span class="ident">SectionIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">SectionIndex</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the COMDAT selection kind.</span>
    <span class="kw">fn</span> <span class="ident">kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">ComdatKind</span>;

    <span class="doccomment">/// Returns the index of the symbol used for the name of COMDAT section group.</span>
    <span class="kw">fn</span> <span class="ident">symbol</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SymbolIndex</span>;

    <span class="doccomment">/// Returns the name of the COMDAT section group.</span>
    <span class="kw">fn</span> <span class="ident">name_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span>;

    <span class="doccomment">/// Returns the name of the COMDAT section group.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the name is not UTF-8.</span>
    <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get the sections in this section group.</span>
    <span class="kw">fn</span> <span class="ident">sections</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::SectionIterator</span>;
}

<span class="doccomment">/// A symbol table.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">ObjectSymbolTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>: <span class="ident">read::private::Sealed</span> {
    <span class="doccomment">/// A symbol table entry.</span>
    <span class="kw">type</span> <span class="ident">Symbol</span>: <span class="ident">ObjectSymbol</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>;

    <span class="doccomment">/// An iterator over the symbols in a symbol table.</span>
    <span class="kw">type</span> <span class="ident">SymbolIterator</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::Symbol</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Get an iterator over the symbols in the table.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This may skip over symbols that are malformed or unsupported.</span>
    <span class="kw">fn</span> <span class="ident">symbols</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident"><span class="self">Self</span>::SymbolIterator</span>;

    <span class="doccomment">/// Get the symbol at the given index.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The meaning of the index depends on the object file.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the index is invalid.</span>
    <span class="kw">fn</span> <span class="ident">symbol_by_index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">index</span>: <span class="ident">SymbolIndex</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Symbol</span><span class="op">&gt;</span>;
}

<span class="doccomment">/// A symbol table entry.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">ObjectSymbol</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>: <span class="ident">read::private::Sealed</span> {
    <span class="doccomment">/// The index of the symbol.</span>
    <span class="kw">fn</span> <span class="ident">index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SymbolIndex</span>;

    <span class="doccomment">/// The name of the symbol.</span>
    <span class="kw">fn</span> <span class="ident">name_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>;

    <span class="doccomment">/// The name of the symbol.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error if the name is not UTF-8.</span>
    <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">str</span><span class="op">&gt;</span>;

    <span class="doccomment">/// The address of the symbol. May be zero if the address is unknown.</span>
    <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// The size of the symbol. May be zero if the size is unknown.</span>
    <span class="kw">fn</span> <span class="ident">size</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;

    <span class="doccomment">/// Return the kind of this symbol.</span>
    <span class="kw">fn</span> <span class="ident">kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SymbolKind</span>;

    <span class="doccomment">/// Returns the section where the symbol is defined.</span>
    <span class="kw">fn</span> <span class="ident">section</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SymbolSection</span>;

    <span class="doccomment">/// Returns the section index for the section containing this symbol.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// May return `None` if the symbol is not defined in a section.</span>
    <span class="kw">fn</span> <span class="ident">section_index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">SectionIndex</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">section</span>().<span class="ident">index</span>()
    }

    <span class="doccomment">/// Return true if the symbol is undefined.</span>
    <span class="kw">fn</span> <span class="ident">is_undefined</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Return true if the symbol is a definition of a function or data object</span>
    <span class="doccomment">/// that has a known address.</span>
    <span class="kw">fn</span> <span class="ident">is_definition</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Return true if the symbol is common data.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note: does not check for `SymbolSection::Section` with `SectionKind::Common`.</span>
    <span class="kw">fn</span> <span class="ident">is_common</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Return true if the symbol is weak.</span>
    <span class="kw">fn</span> <span class="ident">is_weak</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Returns the symbol scope.</span>
    <span class="kw">fn</span> <span class="ident">scope</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SymbolScope</span>;

    <span class="doccomment">/// Return true if the symbol visible outside of the compilation unit.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This treats `SymbolScope::Unknown` as global.</span>
    <span class="kw">fn</span> <span class="ident">is_global</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Return true if the symbol is only visible within the compilation unit.</span>
    <span class="kw">fn</span> <span class="ident">is_local</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Symbol flags that are specific to each file format.</span>
    <span class="kw">fn</span> <span class="ident">flags</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">SymbolFlags</span><span class="op">&lt;</span><span class="ident">SectionIndex</span><span class="op">&gt;</span>;
}

<span class="doccomment">/// An iterator for files that don&#39;t have dynamic relocations.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">NoDynamicRelocationIterator</span>;

<span class="kw">impl</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">NoDynamicRelocationIterator</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> (<span class="ident">u64</span>, <span class="ident">Relocation</span>);

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Item</span><span class="op">&gt;</span> {
        <span class="prelude-val">None</span>
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="object" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>